Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 210556)
+++ channels/chan_sip.c	(working copy)
@@ -18217,7 +18217,7 @@
 /*! \brief Handle responses on REGISTER to services */
 static int handle_response_register(struct sip_pvt *p, int resp, const char *rest, struct sip_request *req, int seqno)
 {
-	int expires, expires_ms;
+	int expires, expires_ms, new_expiry, tmp_expiry;
 	struct sip_registry *r;
 	r=p->registry;
 	
@@ -18257,20 +18257,23 @@
 		}
 		break;
 	case 423:	/* Interval too brief */
-		r->expiry = atoi(get_header(req, "Min-Expires"));
-		ast_log(LOG_WARNING, "Got 423 Interval too brief for service %s@%s, minimum is %d seconds\n", p->registry->username, p->registry->hostname, r->expiry);
+		new_expiry = atoi(get_header(req, "Min-Expires"));
+		ast_log(LOG_WARNING, "Got 423 Interval too brief for service %s@%s, minimum is %d seconds\n", p->registry->username, p->registry->hostname, new_expiry);
 		AST_SCHED_DEL_UNREF(sched, r->timeout, registry_unref(r, "reg ptr unref from handle_response_register 423"));
 		if (r->call) {
 			r->call = dialog_unref(r->call, "unsetting registry->call pointer-- case 423");
 			pvt_set_needdestroy(p, "received 423 response");
 		}
-		if (r->expiry > max_expiry) {
+		if (new_expiry > max_expiry) {
 			ast_log(LOG_WARNING, "Required expiration time from %s@%s is too high, giving up\n", p->registry->username, p->registry->hostname);
-			r->expiry = default_expiry;
 			r->regstate = REG_STATE_REJECTED;
 		} else {
 			r->regstate = REG_STATE_UNREGISTERED;
+
+			tmp_expiry = r->expiry;
+			r->expiry = new_expiry;
 			transmit_register(r, SIP_REGISTER, NULL, NULL);
+			r->expiry = tmp_expiry;
 		}
 		manager_event(EVENT_FLAG_SYSTEM, "Registry", "ChannelType: SIP\r\nUsername: %s\r\nDomain: %s\r\nStatus: %s\r\n", r->username, r->hostname, regstate2str(r->regstate));
 		break;
